package dk.easj.anbo.lee4socket;
/**
 * If emulator keeps getting UnknownHostException try setting the DNS server<br />
 * http://stackoverflow.com/questions/2206822/no-internet-on-android-emulator-why-and-how-to-fix
 * @author andersb
 */
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.Socket;

import android.os.Bundle;
import android.os.NetworkOnMainThreadException;
import android.app.Activity;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;

public class SocketActivity extends Activity {
	private static final String SPECIAL_IP_TO_HOST_COMPUTER = "10.0.2.2";
	private static final int PORT_NUMBER = 8;

	@Override   
	public void onCreate(final Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
	}

	public void buttonClicked(final View view) {
		final EditText editText = (EditText) findViewById(R.id.editText);
 
		final String request = editText.getText().toString();

		// doInBackground
		final String response = getResponse(request); 
		 
		// onPostExecute 
		final TextView textViev = (TextView) findViewById(R.id.textView);
		textViev.setText(response);

	}

	/**
	 * Will throw NetworkOnMainThreadException in API version 11 and up (Honeycomb aka. Android 3.0)
	 * Use AsyncTask to solve the problem, cf. the project Lee4Networking
	 * @param request
	 * @return
	 */
	private String getResponse(final String request) {
		try {
			final Socket socket = new Socket(SPECIAL_IP_TO_HOST_COMPUTER,
					PORT_NUMBER);
			final OutputStream output = socket.getOutputStream();
			output.write((request + "\n").getBytes());
			output.flush();
			final BufferedReader input = new BufferedReader(
					new InputStreamReader(socket.getInputStream()));
			final String line = input.readLine();
			socket.close();
			return line;
		} catch (IOException ex) {
			Log.e("SHIT", ex.toString());
			return ex.toString();
		} catch (Exception ex) {
			// NetworkOnMainThreadException
			Log.e("SHIT", ex.toString());
			return ex.toString();
		}
	}

}
